﻿using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using WCFServiceWebRole1;

namespace BookstoreTest
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestMethod1()
        {
            IBookstoreService bookstore = new BookstoreService();
            IList<Book> books = bookstore.GetBooks();
            Assert.AreEqual(1, books.Count);

            Book book = bookstore.GetBook("1");
            Assert.AreEqual("C# 5.0", book.Title);

            Assert.IsNull(bookstore.GetBook("100"));

            Assert.AreEqual("C# 5.0", bookstore.GetBookTitle("1"));
            Assert.IsNull(bookstore.GetBookTitle("100"));

            Book b1 = new Book { Title = "Essential C# 5.0", Publisher = "Addison Wesley" };
            Book b1Copy = bookstore.AddBook(b1);
            Assert.AreEqual(2, b1Copy.Id);
            Assert.AreEqual("Essential C# 5.0", b1Copy.Title);
            b1Copy.Title = "Strange title";
            Book updatedBook = bookstore.UpdateBook(b1Copy.Id.ToString(), b1Copy);
            Assert.AreEqual("Strange title", updatedBook.Title);

            Book bCopy2 = bookstore.DeleteBook("2");
            Assert.AreEqual(2, bCopy2.Id);
            Assert.AreEqual("Strange title", bCopy2.Title);

            Assert.AreEqual(1, bookstore.GetBooks().Count);

            Assert.IsNull(bookstore.DeleteBook("100"));

        }
    }
}
